config/routes.rb
Rails.application.routes.draw do
	devise_for :users, :controllers => { :omniauth_callbacks => "callbacks" } , path: "auth"

	resources :albums, except: [:index]
	resources :photos , except: [:index]
	resources :users, only: [:show]
 	authenticated :users do
 		root 'users#show'
	end
	unauthenticated :users do
	    root 'photos#discover_photos'
	end

	namespace :admin do
      	resources :albums, except: [:new, :create]
      	resources :users, except: [:new, :create]
      	resources :photos, except: [:new, :create]
      	delete '/delete/images' => 'albums#delete_images', as: :delete_images
		delete '/album/:album_id/delete/:image_id/images_old/' => 'albums#delete_image_attachment', as: :delete_images_old
    end

	get '/feed/photos' => 'photos#feed_photos'
	get '/feed/albums' => 'albums#feed_albums'

	get '/discover/photos' => 'photos#discover_photos'
	get '/discover/albums' => 'albums#discover_albums'

	delete '/delete/images' => 'albums#delete_images', as: :delete_images
	delete '/album/:album_id/delete/:image_id/images_old/' => 'albums#delete_image_attachment', as: :delete_images_old
	
	post '/user/:id/follow_user', to: 'relations#follow_user', as: :follow_user
  	post '/user/:id/unfollow_user', to: 'relations#unfollow_user', as: :unfollow_user

  	post '/:likeable_id/:likeable_type/like', to: 'likes#like', as: :like
  	post '/:likeable_id/:likeable_type/unlike', to: 'likes#unlike', as: :unlike
end

app/models/album.rb
class Album < ApplicationRecord
	belongs_to :user
	has_many :likes, as: :likeable, dependent: :destroy
	has_many_attached :images

	#Create scope
	scope :new_first, -> { order(created_at: :desc)}
	
	#Validation
	validates :title, :description,  presence: true
	validates :title,    length: { in: 1..140 } 
	validates :description,    length: { in: 1..300 }
end

app/controllers/admin/albums_controller.rb
class Admin::AlbumsController < ApplicationController
	before_action :authenticate_user!
	before_action :set_album

	def index
		@album_manage = Album.new_first.page(params[:page]).per(8)
	end

 	def edit
	end

	def update
		set_album()
		if params[:album][:images] != nil
			@album_admin.update(title: params[:album][:title], private: params[:album][:private], images: params[:album][:images],description: params[:album][:description])
			flash[:notice] = "Album edited successfully!"
			@album_manage = Album.new_first.page(params[:page]).per(8)
			render "index"
		elsif params[:album][:images] == nil && @album_admin.title == params[:album][:title]  && @album_admin.description == params[:album][:description] && @album_admin.private.to_s == params[:album][:private] && @album_admin.images.size > 1
			
			@album_admin.update(title: params[:album][:title], private: params[:album][:private], description: params[:album][:description])
			flash[:notice] = "Unchanged through time!"
			@album_manage = Album.new_first.page(params[:page]).per(8)
			render "index"
		else 
			@album_admin.update(title: params[:album][:title], private: params[:album][:private], description: params[:album][:description])
			flash[:alert] = "#{@album_admin.errors.full_messages.join(', ')}"
			redirect_to edit_admin_album_path(@album_admin)
		end
	end

	def destroy
		@album_admin.destroy
		@album_manage = Photo.all.new_first.page(params[:page]).per(8)
		flash[:notice] = "Album delete successfully!"
		render "index"
	end

	def delete_images
	  	@album_admin.images.purge
	  	redirect_to edit_admin_album_path(@album_admin)
	end
	def delete_image_attachment
		@new_album = Album.find(params[:album_id])
	 	@image = @new_album.images.find_by(id: params[:image_id]).purge
	 	redirect_to edit_admin_album_path(@new_album)
	end
 
  private
	def set_album
	    @album_admin = Album.find_by(id: params[:id])
	end
end

app/controllers/albums_controller.rb
class AlbumsController < ApplicationController
	before_action :authenticate_user!
	before_action :set_album
	
	def feed_albums
		list_follow = current_user.following.ids
		@album_manage = Album.new_first.where(private: false, user_id: list_follow).page(params[:page]).per(6)
	end

	def discover_albums
		@album_manage = Album.new_first.where(private: false).page(params[:page]).per(6)
	end

	def new
	    @album = Album.new
	end

	def create
	    @album = current_user.albums.new(album_params)
		if @album.save && @album.images.attached? && @album.images.size <= 25
			flash[:notice] = "Album created successfully!"
			redirect_to current_user
		elsif 
			if @album.images.attached? == false
				flash[:alert] = "Please choose your images"
				render "new"
	    	elsif  @album.images.size >= 25
	    		flash[:alert] = "Maximum 25 images"
	    		render "new"
	  		else
	    		flash[:alert] = "#{@album.errors.full_messages.join(', ')}"
	    		render "new"
	    	end
		end
	end
	
	def show
    	
 	end

 	def edit
	end

	def update
		set_album()
		if params[:album][:private] != @album.private.to_s || params[:album][:title] != @album.title || params[:album][:description] != @album.description

			if params[:album][:images] != nil
				@album.update(title: params[:album][:title], private: params[:album][:private], images: params[:album][:images],description: params[:album][:description])
			else 
				@album.update(title: params[:album][:title], private: params[:album][:private], description: params[:album][:description])
			end 
			flash[:notice] = "Album edited successfully!"
			redirect_to current_user
		elsif params[:album][:images] == nil && @album.title == params[:album][:title]  && @album.description == params[:album][:description]  && @album.private.to_s == params[:album][:private] &&@album.images.size > 1
			@album.update(title: params[:album][:title], private: params[:album][:private], description: params[:album][:description])
			flash[:notice] = "Unchanged through time!"
			redirect_to current_user
		else 
			@album.update(title: params[:album][:title], private: params[:album][:private], description: params[:album][:description])
			flash[:alert] = "#{@album.errors.full_messages.join(', ')}"
			if @album.images.size < 1 
				flash[:alert] = "Album must have 1 photo"
			end
			redirect_to edit_album_path(@album)
		end
	end

	def destroy
		@album.destroy
		redirect_to current_user
	end

	def delete_images
	  	@album.images.purge
	end
	def delete_image_attachment
		# byebug
		@new_album = Album.find(params[:album_id])
	 	@image = @new_album.images.find_by(id: params[:image_id]).purge
	 	redirect_to edit_album_path(@new_album)
	end
 
  private
	def set_album
	    @album = Album.find_by(id: params[:id])
	end
    #strong parameters
    def album_params
      params.require(:album).permit(:title, :description, :private, images:[])
    end
end

app/views/albums/_list_albums.html.erb
<div class="container-body">
	<div class="row">
		<% if albums != nil %> 
			<% albums.each do |alb| %>
				<div class=" col-sm-12 col-lg-6  ">
					<div class="list_album">
						<% if alb.images.size > 0 %>
							<a data-toggle="modal" href="#<%=alb.id%>">
								<div class="col-lg-6 col-sm-6 album">
									<% alb.images.each do |img| %>
										<%= image_tag(img, class: " item small")%>
								 	<%end%>
								 	<div class="capity-photos-2">
										<p class=" col-lg-12 text-capity text"> <%= alb.images.size%> <br> PHOTOS</p>
									</div>
								</div>
							</a>
							<!-- Create The modal -->
								<div class="modal fade" id= "<%=alb.id%>" tabindex="-1" role="dialog" aria-labelledby="modalLabel" aria-hidden="true">
								    <div class="modal-dialog modal-sm" role="document">
								      	<div class="modal-content">
								        	<div class="modal-header">
								          		<h4 class="modal-title" id="modalLabel"><%= alb.title %></h4>
								          		<button type="button" class="close" data-dismiss="modal" aria-label="Close">
								           		 	<span aria-hidden="true">&times;</span>
								         	 	</button>
								        	</div> 
									        <div class="modal-body">
		 										<!-- Wrapper for slides -->
											 	<div id="slide<%=alb.id%>" class="carousel slide" data-ride="carousel">
											 		 <div class="carousel-inner">
											 		 		<% alb.images.each do |img| %>
												 		 		<% if img == alb.images.last %>
												 		 			<div class="item active ">
												 		 		<%else%>
												 		 			<div class="item">
												 		 		<%end%> 		 		
												 		 			<%= image_tag(img, class: "photo")%>
												 		 		</div>
													 		<%end%>	
											 		 </div>		   
												</div>
											 	<!-- Left and right controls -->
											    <a class="left carousel-control" href="#slide<%=alb.id%>" data-slide="prev">
											      <span class="glyphicon glyphicon-chevron-left"></span>
											      <span class="sr-only">Previous</span>
											    </a>
											    <a class="right carousel-control" href="#slide<%=alb.id%>" data-slide="next">
											      <span class="glyphicon glyphicon-chevron-right"></span>
											      <span class="sr-only">Next</span>
											    </a>
									        </div>
									        <div class="modal-footer">
									        	<h3><%= alb.description %></h3> 
									        </div>
								      	</div>
								    </div>
								</div>
							<!-- End The modal -->
							<div class="col-lg-offset-6 col-sm-offset-6 ">
								<div class="col-lg-3 col-sm-3">
									<%= image_tag(alb.user.avatar, class: "avatar photo img-circle") %>
								</div>
								<div class="col-sm-offset-4 col-lg-offset-4 name-user">
									<%= link_to alb.user.full_name, user_path(id: alb.user_id) %>
								</div>
								<form class="col-lg-offset-6 col-sm-offset-6" >
									<% if current_user.id != alb.user_id %>
										<% if current_user.following.ids.include? alb.user_id %>
						                	<%= link_to "Following", unfollow_user_path(id: alb.user_id),  class: 'btn follow-button', id: 'unfollow-button', method: :post %>
							            <%else%>
							                <%= link_to "Follow", follow_user_path(id: alb.user_id),  class: 'btn follow-button', id: 'follow-button', method: :post %>
					           			<%end%>
									<%end%>
								</form>
								<div class="title">
									<% if alb.title.size > 20 %>
					                	<%= alb.title[0..20] + "... " %> 
					                <%else%>
					                 	<%= alb.title %> 
					                <%end%>
								</div>
								<div class="description">
									<% if alb.description.size > 100 %>
					                	<%= alb.description[0..100] + "... " %> 
					                <%else%>
					            	   <%= alb.description %> 
					                <%end%>
								</div>
							</div>
							<div class="col-sm-offset-6  col-lg-offset-6 publication">
								<div class="col-lg-4 col-sm-4 time-post-album">
									<% if  Like.where(likeable_type: "Album", likeable_id: alb.id).pluck(:user_id).include? current_user.id %>
										<%= link_to '<i class="fa fa-heart" style="font-size:36px;" id="like"></i>'.html_safe, unlike_path(likeable_type: "Album", likeable_id: alb.id), method: :post%>
									<%else%>
										<%= link_to '<i class="fa fa-heart" style="font-size:36px;" id="unlike"></i>'.html_safe, like_path(likeable_type: "Album", likeable_id: alb.id), method: :post %>
									<%end%>		
									<%= alb.likes.size%>
								</div>
								<div class="col-lg-8 col-sm-8 time-post-album">
									<p><%=l alb.updated_at, format: :default%></p>
								</div>
							</div>	
						<%end%>
					</div>
				</div>
			<%end%>
			<div class="row col-lg-9 ">
				<%= paginate @album_manage %>
			</div>
		<%end%>
	</div>
</div>

app/views/albums/_show_album.html.erb
<div class="container-body">
	<div class="row col-lg-12">
		<% if current_user.id == @user.id %>
		    <div class="row">
		        <div class=" col-sm-3 col-sm-offset-8 col-lg-2 col-lg-offset-9">
		         	<%= link_to '+ ADD ALBUMS', new_album_path, class: "btn btn-lg  btn-success" %> 
		        </div>
		    </div>
		<%end%>
	</div>
	<div class="row col-lg-12">
		<% if album != nil %> 
			<% album.each do |alb| %>
				<div class="col-lg-3 col-sm-6">
		            <% if current_user.id == @user.id && alb.private == true %>
		                <div class="lock-album col-sm-offset-6 col-lg-offset-8">
		                  	<i class="fa fa-lock" style="font-size: 30px;" id = "lock-icon-album"></i>
		                </div>
		            <%end%>
		            <div class="edit-photo btn " id= "edit-album">
		                <%= link_to "EDIT", edit_album_path(id: alb.id)%>
		            </div>
					<a data-toggle="modal" href="#<%=alb.id%>">
						<div class="album">
							<% alb.images.each do |img| %>
								<%= image_tag(img, class: " item small")%>
						 	<%end%>
						 	<div class="capity-photos-2 ">
								<p class=" col-lg-12 text-capity text"> <%= alb.images.size%> <br> PHOTOS</p>
							</div>
						</div>
						<div class="title-photo col-sm-12 col-lg-12">
							<% if alb.title.size > 20 %>
			                	<%= alb.title[0..20] + "... " %> 
			                <%else%>
			                 	<%= alb.title %> 
			                <%end%>
						</div>
					</a>
					<!-- Create The modal -->
					<div class="modal fade" id= "<%=alb.id%>" tabindex="-1" role="dialog" aria-labelledby="modalLabel" aria-hidden="true">
					    <div class="modal-dialog modal-sm" role="document">
					      	<div class="modal-content">
					        	<div class="modal-header">
					          		<h4 class="modal-title" id="modalLabel"><%= alb.title %></h4>
					          		<button type="button" class="close" data-dismiss="modal" aria-label="Close">
					           		 	<span aria-hidden="true">&times;</span>
					         	 	</button>
					        	</div>
						        <div class="modal-body">
										<!-- Wrapper for slides -->
								 	<div id="slide<%=alb.id%>" class="carousel slide" data-ride="carousel">
								 		 <div class="carousel-inner">
								 		 		<% alb.images.each do |img| %>
									 		 		<% if img == alb.images.last %>
									 		 			<div class="item active ">
									 		 		<%else%>
									 		 			<div class="item">
									 		 		<%end%> 		 		
									 		 			<%= image_tag(img, class: "photo rounded mx-auto d-block")%>
									 		 		</div>
										 		<%end%>	
								 		 </div>		   
									</div>
								 	<!-- Left and right controls -->
								    <a class="left carousel-control" href="#slide<%=alb.id%>" data-slide="prev">
								      	<span class="glyphicon glyphicon-chevron-left"></span>
								      	<span class="sr-only">Previous</span>
								    </a>
								    <a class="right carousel-control" href="#slide<%=alb.id%>" data-slide="next">
								      	<span class="glyphicon glyphicon-chevron-right"></span>
								      	<span class="sr-only">Next</span>
								    </a>
						        </div>
						        <div class="modal-footer">
						        	<%= alb.description %> 
						        </div>
					      	</div>
					    </div>
					</div>
					<!-- End The modal -->
				</div>
			<%end%>
		<%end%>
	</div>
	<div class="row col-lg-12 col-sm-12">
		<%= paginate album%>
	</div>
</div>

app/views/albums/discover_albums.html.erb
<%= render 'share/option_status' %>
<div class="row">
     <div class="col-sm-offset-4 col-lg-offset-5 show-header">
        <%= link_to 'PHOTO', discover_photos_path, class: "btn btn-lg btn-option" %> 
        <%= link_to 'ALBUM', discover_albums_path, class: "btn btn-lg btn-option btn-option-click"%> 
    </div>
</div>
<!--Start container -->
<%= render 'list_albums', albums: @album_manage %>
<!--End container-->

app/views/albums/edit.html.erb
<%= render 'share/option_status' %>
<div class="container-body col-lg-10 col-lg-offset-1">
  	<div class="title-page col-lg-12">
  		<div class="row col-lg-6 col-sm-6">
  			<p> Edit Album</p>
  		</div>
    	<div class="col-lg-offset-11 col-sm-offset-10">
    		<%= link_to '<button class="btn btn-lg btn-primary white-btn">Back</button>'.html_safe, user_path(id: current_user.id) %>
    	</div>
  	</div>
	<div class="row">
	    <div class="col-lg-12 col-sm-12">  
	    	<%= form_for(@album, url: album_path(@album), html: { method: :put }) do |f| %>
	      		<div class="row album_wall">
			        <% if notice && notice != "Signed in successfully." && notice !="Your account has been updated successfully." %><div class="alert alert-info"><%= notice %></div><% end %>
			        <% if alert %><div class="alert alert-danger"><%= alert %></div><% end %>
			        <div class="row col-lg-12">
			          	<div class="col-lg-6">
				            <div class="form-group">
				              	<%= f.label :title %>
				              	<%= f.text_field :title, autofocus: true, class: 'form-control', require: true %>
				            </div>
				        </div>
				        <div class="col-lg-6">
				            <div class="form-group">
				             	<%= f.label :description %>
				             	<%= f.text_field :description, class: 'form-control', require: true %>
				            </div>
				        </div>
			        </div>
			        <div class="row col-lg-12">
				          <div class="form-group col-lg-6 ">
				            <%= f.label "Sharing mode" %>
				            <% if @album.private == true%>
								<%= f.select(:private, options_for_select([['Private', true], ['Public', false]] ), {}, {:class => 'form-control'})  %>
				            <% else %>
								<%= f.select(:private, options_for_select([['Public', false], ['Private', true]] ), {}, {:class => 'form-control'})  %>
				            <% end %>   
			        	</div>
			        </div>
		        
			        <div class="row form-group col-lg-13 ">
			        	<% i = 0%>
			        	<% @album.images.each do |images|%>
				        	<div class="col-lg-4 col-sm-6 edit-album album-old " id="old-image<%=i%>">
				        		<%= link_to '<i class="fa fa-window-close fa-2x close-icon " aria-hidden="true" id = "close-icon-old"></i>'.html_safe, delete_images_old_path(album_id: @album.id, image_id: images.id), method: :delete, remote: true%>
					            <%= image_tag(images, class: "photo medium", id: i) %>
				        	</div>
				        	<% i = i +1%>
			        	<% end%>
			        	<div class="gallery-album col-lg-13 col-sm-12 " id= "gallery-album"> 
			        		<div class="col-lg-4 col-sm-6 edit-album album-old " id="">
			        			<%= link_to url: delete_images_path do %>
				        			<i class="fa fa-window-close fa-2x close-icon" aria-hidden="true" id = "close-icon" onclick="closeImage(<%=i%>)"></i>
				        		<%end%>
					            <img class="photo medium photo-in">
				        	</div>
							<!-- Photo show here  -->
						</div>

						<label for="gallery-photo-add-album" class="label-upload edit-album " id = "photo-up"  >
			              	<i class="fa fa-plus" style="font-size:70px; color: #BDBDBD;" id = "plus-icon"></i>
			            </label>
			            <%= f.file_field :images, multiple: true, id: "gallery-photo-add-album", class: "form-group hidden"%>
			        </div>
			        <div class="row col-lg-12">
			        	<%= f.submit 'Save', class: 'btn btn-success btn-lg search ' %>
			        	<button class="btn btn-lg btn-danger col-lg-offset-2 ">
			        		<i class="fa fa-trash" aria-hidden="true"></i>
			        		<%= link_to "Delete", album_path(id: @album.id), method: :DELETE, class: "white-btn"%>
			        	</button>
			        </div>
		      	</div>
		    <% end %>
		</div>
	</div>
</div>

app/views/albums/feed_albums.html.erb
<%= render 'share/option_status' %>
<div class="row">
     <div class="col-sm-offset-4 col-lg-offset-5 show-header">
        <%= link_to 'PHOTO', feed_photos_path, class: "btn btn-lg btn-option" %> 
        <%= link_to 'ALBUM', feed_albums_path, class: "btn btn-lg btn-option btn-option-click"%> 
    </div>
</div>
<!--Start container -->
<%= render 'list_albums', albums: @album_manage %>
<!--End container-->

app/views/albums/new.html.erb
<%= render 'share/option_status' %>
<div class="container-body col-lg-10 col-lg-offset-1">
	<div class="title-page col-lg-12">
	    <div class="row col-lg-6 col-sm-6">
  			<p> New Album</p>
  		</div>
    	<div class="col-lg-offset-11 col-sm-offset-10">
			<%= link_to '<button class="btn btn-lg btn-primary white-btn">Back</button>'.html_safe, user_path(id: current_user.id) %>
		</div>
	</div>
	 <div class="row">
	    <div class="col-lg-12">  
			<%= form_for (@album)  do |f| %>
			    <div class="row album_wall">
			        <% if notice && notice != "Signed in successfully." %><div class="alert alert-info"><%= notice %></div><% end %>
			        <% if alert %><div class="alert alert-danger"><%= alert %></div><% end %>
			        <div class="row col-lg-12">
				        <div class="col-lg-6">
				            <div class="form-group">
				              	<%= f.label :title %>
				              	<%= f.text_field :title, class: 'form-control', require: true, autofocus: true%>
				            </div>
				        </div>
				        <div class="col-lg-6">
				            <div class="form-group">
				              	<%= f.label :description %>
				             	 <%= f.text_field :description, class: 'form-control', autofocus: false, require: true %>
				            </div>
				        </div>
			        </div>
			        <div class="row col-lg-12">
				        <div class="form-group col-lg-6 ">
				           	<%= f.label "Sharing mode" %>
				            <%= f.select(:private, options_for_select([['Public', false], ['Private', true]] ), {}, {:class => 'form-control'})  %>
				        </div>
			        </div>
					<div class="form-group col-lg-13">
						<div id="image-upload" >
							<div class="row col-lg-12">
								<div class="col-lg-12 form-group" id="out"> 
									<!-- Photo show here  -->
								</div>
								<div class="col-lg-12 row">
									<div class="medium frame-photo">
										<label for="gallery-photo-add" class="label-upload medium">
								            <i class="fa fa-plus" style="font-size:70px; color: #BDBDBD;" id = "plus"></i>
								        </label>
										<%= f.file_field :images, multiple: true, id: "gallery-photo-add", class: "form-group hidden"%>
									</div>
								</div>
							</div>
							<br> 
							<div class="col-lg-12">
								
				            <%= f.submit 'Upload', class: 'btn btn-success btn-lg search' %>
							</div>
				          </div>
			        </div>
		      	</div>
	      	<% end %>
	    </div>
	 </div>
</div>